'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _Expression2 = require('../Expression');

var _Expression3 = _interopRequireDefault(_Expression2);

var _utilsGetFunctionParams = require('./utils/getFunctionParams');

var _utilsGetFunctionParams2 = _interopRequireDefault(_utilsGetFunctionParams);

var FunctionExpression = (function (_Expression) {
    _inherits(FunctionExpression, _Expression);

    // TODO: get params from Property in case of setter

    function FunctionExpression(childNodes) {
        _classCallCheck(this, FunctionExpression);

        _get(Object.getPrototypeOf(FunctionExpression.prototype), 'constructor', this).call(this, 'FunctionExpression', childNodes);
    }

    _createClass(FunctionExpression, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var params = [];
            var id = null;
            var generator = false;
            var async = false;

            if (children.isToken('Punctuator', '(')) {
                params = (0, _utilsGetFunctionParams2['default'])(children);
                children.skipNonCode();
            } else {
                if (children.isToken('Identifier', 'async')) {
                    async = true;
                    children.passToken('Identifier', 'async');
                    children.skipNonCode();
                }

                children.passToken('Keyword', 'function');
                children.skipNonCode();

                if (children.isToken('Punctuator', '*')) {
                    generator = true;
                    children.moveNext();
                    children.skipNonCode();
                }

                if (children.isNode('Identifier')) {
                    id = children.passNode();
                    children.skipNonCode();
                }

                params = (0, _utilsGetFunctionParams2['default'])(children);
                children.skipNonCode();
            }

            var body = children.passStatement();

            children.assertEnd();

            this._async = async;
            this._id = id;
            this._params = params;
            this._body = body;
            this._generator = generator;
        }
    }, {
        key: 'async',
        get: function get() {
            return this._async;
        }
    }, {
        key: 'params',
        get: function get() {
            return this._params.concat();
        }
    }, {
        key: 'body',
        get: function get() {
            return this._body;
        }
    }, {
        key: 'expression',
        get: function get() {
            return false;
        }
    }, {
        key: 'id',
        get: function get() {
            return this._id;
        }
    }, {
        key: 'generator',
        get: function get() {
            return this._generator;
        }
    }]);

    return FunctionExpression;
})(_Expression3['default']);

exports['default'] = FunctionExpression;
module.exports = exports['default'];