'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _Expression2 = require('../Expression');

var _Expression3 = _interopRequireDefault(_Expression2);

var updateOperators = {
    '++': true,
    '--': true
};

var UpdateExpression = (function (_Expression) {
    _inherits(UpdateExpression, _Expression);

    // TODO: Should respect operator precedence: putting "++a" after "b" without parens should raise an error.

    function UpdateExpression(childNodes) {
        _classCallCheck(this, UpdateExpression);

        _get(Object.getPrototypeOf(UpdateExpression.prototype), 'constructor', this).call(this, 'UpdateExpression', childNodes);
    }

    _createClass(UpdateExpression, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var operator = undefined;
            var argument = undefined;
            var prefix = undefined;

            if (children.isToken('Punctuator', updateOperators)) {
                operator = children.passToken().value;
                children.skipNonCode();
                argument = children.passAssignable();
                prefix = true;
            } else {
                argument = children.passAssignable();
                children.skipNonCode();
                operator = children.passToken().value;
                prefix = false;
            }

            children.assertEnd();

            this._argument = argument;
            this._operator = operator;
            this._prefix = prefix;
        }
    }, {
        key: 'argument',
        get: function get() {
            return this._argument;
        }
    }, {
        key: 'operator',
        get: function get() {
            return this._operator;
        }
    }, {
        key: 'prefix',
        get: function get() {
            return this._prefix;
        }
    }]);

    return UpdateExpression;
})(_Expression3['default']);

exports['default'] = UpdateExpression;
module.exports = exports['default'];