'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _Statement2 = require('../Statement');

var _Statement3 = _interopRequireDefault(_Statement2);

var validKinds = {
    'var': true,
    'let': true,
    'const': true
};

var VariableDeclaration = (function (_Statement) {
    _inherits(VariableDeclaration, _Statement);

    // TODO: Can only have 1 declarator inside for ... in.

    function VariableDeclaration(childNodes) {
        _classCallCheck(this, VariableDeclaration);

        _get(Object.getPrototypeOf(VariableDeclaration.prototype), 'constructor', this).call(this, 'VariableDeclaration', childNodes);
    }

    _createClass(VariableDeclaration, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var kind = children.passToken('Keyword', validKinds).value;
            children.skipNonCode();

            var declarations = [];

            declarations.push(children.passNode('VariableDeclarator'));
            children.skipNonCode();

            while (children.isToken('Punctuator', ',')) {
                children.passToken();
                children.skipNonCode();
                declarations.push(children.passNode('VariableDeclarator'));
                children.skipNonCode();
            }

            children.skipSemicolon();
            children.assertEnd();

            this._kind = kind;
            this._declarations = declarations;
        }
    }, {
        key: 'kind',
        get: function get() {
            return this._kind;
        }
    }, {
        key: 'declarations',
        get: function get() {
            return this._declarations.concat();
        }
    }]);

    return VariableDeclaration;
})(_Statement3['default']);

exports['default'] = VariableDeclaration;
module.exports = exports['default'];